--	Package File Template
--
--	Purpose: This package defines supplemental types, subtypes, 
--		 constants, and functions 


library IEEE;
use IEEE.STD_LOGIC_1164.all;

package CPU_PACKAGE is
	
	constant BIT_WIDTH:integer 	:= 4 ;
	constant RAM_SIZE:integer		:= 256 ;
	-- Typdeklarationen
	subtype Data is STD_LOGIC_VECTOR(BIT_WIDTH-1 downto 0) ;
	subtype Adress is STD_LOGIC_VECTOR(2*BIT_WIDTH-1 downto 0) ;
	subtype DoubleNibble is STD_LOGIC_VECTOR(2*BIT_WIDTH-1 downto 0) ;
	subtype Instruction is STD_LOGIC_VECTOR(11 downto 0) ;
		
	-- OPCodes
	constant HLT_Inst:Data 			:= "0000" ;
	constant LOAD_Inst:Data 		:= "0001" ;
	constant STORE_Inst:Data		:= "0010" ;
	constant JMP_Inst:Data			:= "0011" ;
	constant SPC_Inst:Data			:= "0100" ;
	constant AND_Inst:Data			:= "0101" ;
	constant OR_Inst:Data			:= "0110" ;
	constant ADD_Inst:Data 			:= "0111" ;
	constant SUB_Inst:Data 			:= "1000" ;
	constant JNZ_Inst:Data			:= "1001" ;
	constant CMP_Inst:Data			:= "1010" ;
	constant JND_Inst:Data			:= "1011" ;
	constant JNC_Inst:Data			:= "1100" ;
	constant ROL_Inst:Data			:= "1101" ;
	constant ROR_Inst:Data			:= "1110" ;
	constant CLF_Inst:Data			:= "1111" ;
	
end CPU_PACKAGE;
